/* ALU block for computer #3
 * Michael Robinson
 * 9 November 2001 
 */

`timescale 1ns/10ps

module alu( a, b, s, f, cond );
input [3:0] a;
input [3:0] b;
input [2:0] s;

output [3:0] f;
output [3:0] cond;

wire [3:0] cond;
reg [3:0] f;

// Temporary...
assign cond[0] = ((a+b)>15); // Carry out
assign cond[1] = (a==b); // Equality
assign cond[2] = 0; // Generate_
assign cond[3] = 0; // Propagate_

// Operation select (Bogus right now)
always @( s or a or b ) begin
   case(s)
   3'h0: f = a + b;
   3'h1: f = a - b;
   3'h2: f = a & b;
   3'h3: f = a | b;
   3'h4: f = a ^ b;
   3'h5: f = a;
   3'h6: f = b;
   3'h7: f = 0;
   endcase
end

endmodule
